VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3060
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   4560
   LinkTopic       =   "Form1"
   ScaleHeight     =   3060
   ScaleWidth      =   4560
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command2 
      Caption         =   "Advanced PDF"
      Height          =   495
      Left            =   1680
      TabIndex        =   1
      Top             =   1320
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Create PDF"
      Height          =   495
      Left            =   1680
      TabIndex        =   0
      Top             =   360
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Command1_Click()
    ' Create a simple PDF file using the mjwPDF class
    Dim objPDF As New mjwPDF
    
    ' Set the PDF title and filename
    objPDF.PDFTitle = "Test PDF Document"
    objPDF.PDFFileName = App.Path & "\test.pdf"
    
    ' We must tell the class where the PDF fonts are located
    objPDF.PDFLoadAfm = App.Path & "\Fonts"
    
    ' View the PDF file after we create it
    objPDF.PDFView = True
    
    ' Begin our PDF document
    objPDF.PDFBeginDoc
        ' Set the font name, size, and style
        objPDF.PDFSetFont FONT_ARIAL, 15, FONT_BOLD
        
        ' Set the text color
        objPDF.PDFSetTextColor = vbBlue
        
        ' Set the text we want to print
        objPDF.PDFTextOut "Hello, World! From mjwPDF (www.vb6.us)"
    
    ' End our PDF document (this will save it to the filename)
    objPDF.PDFEndDoc
End Sub

Private Sub Command2_Click()
    ' Create a simple PDF file using the mjwPDF class
    Dim objPDF As New mjwPDF
    
    ' Set the PDF title and filename
    objPDF.PDFTitle = "Test PDF Document"
    objPDF.PDFFileName = App.Path & "\test.pdf"
    
    ' We must tell the class where the PDF fonts are located
    objPDF.PDFLoadAfm = App.Path & "\Fonts"
    
    ' Set the file properties
    objPDF.PDFSetLayoutMode = LAYOUT_DEFAULT
    objPDF.PDFFormatPage = FORMAT_A4
    objPDF.PDFOrientation = ORIENT_PORTRAIT
    objPDF.PDFSetUnit = UNIT_PT
    
    ' Lets us set see the bookmark pane when we view the PDF
    objPDF.PDFUseOutlines = True
    
    ' View the PDF file after we create it
    objPDF.PDFView = True
    
    ' Begin our PDF document
    objPDF.PDFBeginDoc
        ' Lets add a heading
        objPDF.PDFSetFont FONT_ARIAL, 15, FONT_BOLD
        objPDF.PDFSetDrawColor = vbRed
        objPDF.PDFSetTextColor = vbWhite
        objPDF.PDFSetAlignement = ALIGN_CENTER
        objPDF.PDFSetBorder = BORDER_ALL
        objPDF.PDFSetFill = True
        objPDF.PDFCell "A centered heading", 15, 15, _
            objPDF.PDFGetPageWidth - 30, 40
            
        ' Lets draw a dashed red square
        objPDF.PDFSetLineColor = vbRed
        objPDF.PDFSetFill = True
        objPDF.PDFSetLineStyle = pPDF_DASHDOT
        objPDF.PDFSetLineWidth = 1
        objPDF.PDFSetDrawMode = DRAW_NORMAL
        objPDF.PDFDrawPolygon Array(300, 150, 400, 150, 400, 250, 300, 250)
        
        ' Lets draw an elipse
        objPDF.PDFSetDrawColor = vbYellow
        objPDF.PDFSetLineColor = vbBlack
        objPDF.PDFSetLineStyle = pPDF_DASHDOT
        objPDF.PDFSetLineWidth = 1.25
        objPDF.PDFSetDrawMode = DRAW_DRAWBORDER
        objPDF.PDFDrawEllipse 300, 150, 75, 25
        
        AddPageNumber objPDF, 1
        
        'Lets add a bookmark to the start of page 1
        objPDF.PDFSetBookmark "A. Page 1", 0, 0
        
        'Now a bookmark half way down page 1
        objPDF.PDFSetBookmark "A1. Page 1 Halfway down", 1, 300
        
        'Now one at the end page 1
        objPDF.PDFSetBookmark "A2. End of Page 1", 1, 500
        
        'Another one a little further down and shows nesting
        objPDF.PDFSetBookmark "A2-Sub1.", 2, 800
        
        objPDF.PDFEndPage
        
        'Start page 2
        objPDF.PDFNewPage
        
        'Lets add an image to page 2
        objPDF.PDFImage App.Path & "\logo.jpg", _
            15, 15, 50, 50, "http://www.vb6.us"
            
        'Lets add a bookmark to the start of page 2
        objPDF.PDFSetBookmark "Page 2", 0, 0
        
        'Now a bookmark just below the logo
        objPDF.PDFSetBookmark "Page 2 just below logo", 1, 75
        
        AddPageNumber objPDF, 2
    
    ' End our PDF document (this will save it to the filename)
    objPDF.PDFEndDoc
End Sub

' Adds the page number to the current page
Private Sub AddPageNumber(objPDF As mjwPDF, pageNumber As Integer)
    Dim sPageInfo As String
    Dim fontSize As Double
    Dim margin As Double
    
    fontSize = 10       'Size of font to use
    margin = 40         'Size of margin (left, right, bottom)
    
    ' Set what we want to print for page info
    sPageInfo = "Page " & pageNumber
    
    ' Should save these settings and change them back for more robust code
    objPDF.PDFSetTextColor = vbBlack
    objPDF.PDFSetAlignement = ALIGN_RIGHT
    objPDF.PDFSetFont FONT_ARIAL, Conversion.CInt(fontSize), FONT_NORMAL
    objPDF.PDFSetFill = False
    
    ' Uncomment the below line if you want to see how our formating works
    'objPDF.PDFSetBorder = BORDER_ALL
    
    ' Draw the page number at the bottom of the page to the right
    objPDF.PDFCell sPageInfo, _
        margin, _
        objPDF.PDFGetPageHeight - margin - fontSize, _
        objPDF.PDFGetPageWidth - (margin * 2), _
        fontSize
End Sub




Private Sub OLD_TEST()

    Dim PDFPrinter As New PDFPrinter
        
    PDFPrinter.PDFTitle = "Test"
    
    PDFPrinter.PDFFileName = App.Path & "\Defaut.pdf"

    PDFPrinter.PDFLoadAfm = App.Path & "\Fonts"
    PDFPrinter.PDFConfirm = False
    PDFPrinter.PDFView = True
    PDFPrinter.PDFWatermark = "www.vb6.us"
    
    PDFPrinter.PDFSetViewerPreferences = VIEW_HIDEMENUBAR & VIEW_HIDETOOLBAR
    PDFPrinter.PDFFormatPage = FORMAT_A4
    PDFPrinter.PDFOrientation = ORIENT_PORTRAIT
    PDFPrinter.PDFSetUnit = UNIT_PT
    PDFPrinter.PDFSetZoomMode = ZOOM_FULLWIDTH
    PDFPrinter.PDFSetLayoutMode = LAYOUT_DEFAULT
    PDFPrinter.PDFUseOutlines = True
    PDFPrinter.PDFUseThumbs = False
    
    PDFPrinter.PDFBeginDoc
        PDFPrinter.PDFSetLineStyle = pPDF_SOLID
        PDFPrinter.PDFSetLineWidth = 1
        PDFPrinter.PDFDrawLine 15, 20, 550, 20

        PDFPrinter.PDFSetBookmark "Signet 1", 0, 40
        PDFPrinter.PDFSetBookmark "Sous-Signet 2", 1, 60
        
        PDFPrinter.PDFSetFont FONT_ARIAL, 15, FONT_BOLD
        PDFPrinter.PDFSetTextColor = vbBlack
        PDFPrinter.PDFTextOut "Signet", 15, 40

        PDFPrinter.PDFSetFont FONT_ARIAL, 15, FONT_BOLD & FONT_UNDERLINE
        PDFPrinter.PDFSetTextColor = vbRed
        PDFPrinter.PDFTextOut "Sous-Signet 1", 15, 60

        PDFPrinter.PDFSetFont FONT_TIMES, 12, FONT_BOLD
        PDFPrinter.PDFSetDrawColor = vbRed
        PDFPrinter.PDFSetTextColor = vbWhite
        PDFPrinter.PDFSetAlignement = ALIGN_FJUSTIFY
        PDFPrinter.PDFSetBorder = BORDER_ALL
        PDFPrinter.PDFSetFill = True
        PDFPrinter.PDFCell "Test Alignement Force Justified", 15, 90, 400, 40, "http://vb6.us"

        PDFPrinter.PDFSetFont FONT_COURIER, 12, FONT_BOLD
        PDFPrinter.PDFSetDrawColor = vbBlue
        PDFPrinter.PDFSetTextColor = vbWhite
        PDFPrinter.PDFSetAlignement = ALIGN_CENTER
        PDFPrinter.PDFSetBorder = BORDER_NONE
        PDFPrinter.PDFSetFill = True
        PDFPrinter.PDFCell "Test Alignement Center", 15, 140, 400, 40

        PDFPrinter.PDFSetFont FONT_ARIAL, 12, FONT_BOLD & FONT_UNDERLINE
        PDFPrinter.PDFSetDrawColor = vbYellow
        PDFPrinter.PDFSetTextColor = vbBlack
        PDFPrinter.PDFSetAlignement = ALIGN_LEFT
        PDFPrinter.PDFSetBorder = BORDER_ALL
        PDFPrinter.PDFSetFill = True
        PDFPrinter.PDFCell "Test Alignement Left", 15, 190, 400, 40

        PDFPrinter.PDFSetLineColor = vbGreen
        PDFPrinter.PDFSetLineWidth = 0.5
        PDFPrinter.PDFSetLineStyle = pPDF_DASHDOTDOT
        PDFPrinter.PDFDrawLineVer 15, 250, 100

        PDFPrinter.PDFSetLineColor = vbRed
        PDFPrinter.PDFSetLineWidth = 1
        PDFPrinter.PDFSetLineStyle = pPDF_DASH
        PDFPrinter.PDFDrawLineHor 30, 250, 100

        PDFPrinter.PDFSetTextColor = vbBlack
        PDFPrinter.PDFTextOut "Lien hypertext : ", 30, 280
        PDFPrinter.PDFLink 140, 280, "http://www.google.fr"

        PDFPrinter.PDFSetTextColor = vbBlack
        PDFPrinter.PDFSetRotation = 15
        PDFPrinter.PDFTextOut "Lien hypertext : ", 30, 330
        PDFPrinter.PDFLink 140, 330, "http://www.club-internet.fr"

        PDFPrinter.PDFSetDrawColor = vbGreen
        PDFPrinter.PDFSetLineColor = vbMagenta
        PDFPrinter.PDFSetLineStyle = pPDF_DASH
        PDFPrinter.PDFSetLineWidth = 0.5
        PDFPrinter.PDFSetDrawMode = DRAW_DRAWBORDER
        PDFPrinter.PDFDrawRectangle 15, 360, 400, 50, "Essai URL"

        PDFPrinter.PDFSetLineColor = vbBlack
        PDFPrinter.PDFSetLineStyle = pPDF_SOLID
        PDFPrinter.PDFSetLineWidth = 1
        PDFPrinter.PDFSetDrawMode = DRAW_NORMAL
        PDFPrinter.PDFDrawRectangle 15, 430, 400, 50

        PDFPrinter.PDFSetDrawColor = vbYellow
        PDFPrinter.PDFSetLineColor = vbCyan
        PDFPrinter.PDFSetLineStyle = pPDF_DASH
        PDFPrinter.PDFSetLineWidth = 0.75
        PDFPrinter.PDFSetDrawMode = DRAW_DRAWBORDER
        PDFPrinter.PDFDrawPolygon Array(15, 520, 150, 520, 75, 570)

        PDFPrinter.PDFSetDrawColor = vbMagenta
        PDFPrinter.PDFSetLineColor = vbWhite
        PDFPrinter.PDFSetLineStyle = pPDF_DASHDOT
        PDFPrinter.PDFSetLineWidth = 1.25
        PDFPrinter.PDFSetDrawMode = DRAW_DRAW
        PDFPrinter.PDFDrawPolygon Array(200, 520, 300, 520, 250, 570)

        PDFPrinter.PDFSetDrawColor = vbWhite
        PDFPrinter.PDFSetLineColor = vbRed
        PDFPrinter.PDFSetLineStyle = pPDF_DASHDOT
        PDFPrinter.PDFSetLineWidth = 0.5
        PDFPrinter.PDFSetDrawMode = DRAW_NORMAL
        PDFPrinter.PDFDrawPolygon Array(350, 520, 425, 520, 375, 570)

        PDFPrinter.PDFSetDrawColor = vbCyan
        PDFPrinter.PDFSetLineColor = vbRed
        PDFPrinter.PDFSetLineStyle = pPDF_DASH
        PDFPrinter.PDFSetLineWidth = 0.75
        PDFPrinter.PDFSetDrawMode = DRAW_DRAWBORDER
        PDFPrinter.PDFDrawPolygon Array(475, 520, 525, 520, 575, 570)

        PDFPrinter.PDFSetLineColor = vbWhite
        PDFPrinter.PDFSetDrawColor = vbGreen
        PDFPrinter.PDFSetLineStyle = pPDF_SOLID
        PDFPrinter.PDFSetLineWidth = 1
        PDFPrinter.PDFSetDrawMode = DRAW_DRAW
        PDFPrinter.PDFDrawEllipse 25, 645, 75, 25

        PDFPrinter.PDFSetLineColor = vbBlue
        PDFPrinter.PDFSetLineStyle = pPDF_DASH
        PDFPrinter.PDFSetLineWidth = 0.25
        PDFPrinter.PDFSetDrawMode = DRAW_NORMAL
        PDFPrinter.PDFDrawEllipse 110, 620, 75

        PDFPrinter.PDFSetDrawColor = vbMagenta
        PDFPrinter.PDFSetLineColor = vbCyan
        PDFPrinter.PDFSetLineStyle = pPDF_DASH
        PDFPrinter.PDFSetLineWidth = 0.75
        PDFPrinter.PDFSetDrawMode = DRAW_DRAWBORDER
        PDFPrinter.PDFDrawEllipse 210, 620, 75

        PDFPrinter.PDFSetLineColor = vbWhite
        PDFPrinter.PDFSetDrawColor = vbRed
        PDFPrinter.PDFSetLineStyle = pPDF_SOLID
        PDFPrinter.PDFSetLineWidth = 1
        PDFPrinter.PDFSetDrawMode = DRAW_DRAW
        PDFPrinter.PDFDrawEllipse 310, 620, 75

        PDFPrinter.PDFSetLineColor = vbBlack
        PDFPrinter.PDFSetLineStyle = pPDF_DASHDOTDOT
        PDFPrinter.PDFSetLineWidth = 1.75
        PDFPrinter.PDFSetDrawMode = DRAW_NORMAL
        PDFPrinter.PDFDrawEllipse 425, 620, 25, 75

        PDFPrinter.PDFSetDrawColor = vbYellow
        PDFPrinter.PDFSetLineColor = vbWhite
        PDFPrinter.PDFSetLineStyle = pPDF_DASHDOT
        PDFPrinter.PDFSetLineWidth = 1.25
        PDFPrinter.PDFSetDrawMode = DRAW_DRAWBORDER
        PDFPrinter.PDFDrawEllipse 475, 645, 75, 25, "http://www.voila.fr"

        PDFPrinter.PDFSetFont FONT_ARIAL, 8, FONT_ITALIC
        PDFPrinter.PDFSetTextColor = vbBlack
        PDFPrinter.PDFTextOut "Page " & PDFPrinter.PDFPageNumber, _
                         PDFPrinter.PDFGetPageWidth / 2 - PDFPrinter.PDFGetStringWidth("Page " & PDFPrinter.PDFPageNumber), _
                         PDFPrinter.PDFGetPageHeight - PDFPrinter.PDFTextHeight

        PDFPrinter.PDFEndPage
        
        PDFPrinter.PDFNewPage

        PDFPrinter.PDFSetBookmark "Signet 2", 0, 40
        PDFPrinter.PDFSetBookmark "Sous-Signet 2", 1, 60
        
        PDFPrinter.PDFSetFont FONT_ARIAL, 15, FONT_BOLD
        PDFPrinter.PDFSetTextColor = vbBlack
        PDFPrinter.PDFTextOut "Signet 2", 15, 40

        PDFPrinter.PDFSetFont FONT_ARIAL, 15, FONT_BOLD & FONT_UNDERLINE
        PDFPrinter.PDFSetTextColor = vbRed
        PDFPrinter.PDFTextOut "Sous-Signet 2", 15, 60
        
        PDFPrinter.PDFSetDrawColor = vbCyan
        PDFPrinter.PDFSetLineColor = vbMagenta
        PDFPrinter.PDFSetLineStyle = pPDF_SOLID
        PDFPrinter.PDFSetLineWidth = 0.65
        PDFPrinter.PDFSetDrawMode = DRAW_DRAW
        PDFPrinter.PDFDrawRectangle 15, 80, 400, 50

        PDFPrinter.PDFSetLineColor = vbBlue
        PDFPrinter.PDFSetLineStyle = pPDF_SOLID
        PDFPrinter.PDFSetLineWidth = 0.85
        PDFPrinter.PDFSetDrawMode = DRAW_NORMAL
        PDFPrinter.PDFDrawRectangle 15, 150, 400, 50

        PDFPrinter.PDFImage App.Path & "\NeO78.jpg", 15, 220, 150, 100, "http://www.google.fr"
        
        PDFPrinter.PDFSetFont FONT_ARIAL, 12, FONT_BOLD
        PDFPrinter.PDFSetTextColor = vbBlack
        PDFPrinter.PDFSetDrawColor = vbYellow
        PDFPrinter.PDFSetLineColor = vbBlack
        PDFPrinter.PDFSetAlignement = ALIGN_LEFT
        PDFPrinter.PDFSetBorder = BORDER_ALL
        PDFPrinter.PDFSetLineWidth = 1
        PDFPrinter.PDFSetFill = True
        PDFPrinter.PDFCell "Test Alignement  Gauche", 15, 350, 150, 20
        
        PDFPrinter.PDFSetFont FONT_ARIAL, 8, FONT_ITALIC
        PDFPrinter.PDFSetTextColor = vbBlack
        PDFPrinter.PDFTextOut "Page " & PDFPrinter.PDFPageNumber, _
                         PDFPrinter.PDFGetPageWidth / 2 - PDFPrinter.PDFGetStringWidth("Page " & PDFPrinter.PDFPageNumber), _
                         PDFPrinter.PDFGetPageHeight - PDFPrinter.PDFTextHeight
    
        PDFPrinter.PDFEndPage
        
        PDFPrinter.PDFNewPage

        PDFPrinter.PDFSetBookmark "Signet 2", 0, 40
        PDFPrinter.PDFSetBookmark "Sous-Signet 2", 1, 60
        
        PDFPrinter.PDFSetFont FONT_ARIAL, 15, FONT_BOLD
        PDFPrinter.PDFSetTextColor = vbBlack
        PDFPrinter.PDFTextOut "Signet 2", 15, 40

        PDFPrinter.PDFSetFont FONT_ARIAL, 15, FONT_BOLD & FONT_UNDERLINE
        PDFPrinter.PDFSetTextColor = vbRed
        PDFPrinter.PDFTextOut "Sous-Signet 2", 15, 60
        
        PDFPrinter.PDFSetDrawColor = vbCyan
        PDFPrinter.PDFSetLineColor = vbMagenta
        PDFPrinter.PDFSetLineStyle = pPDF_SOLID
        PDFPrinter.PDFSetLineWidth = 0.65
        PDFPrinter.PDFSetDrawMode = DRAW_DRAW
        PDFPrinter.PDFDrawRectangle 15, 80, 400, 50

        PDFPrinter.PDFSetLineColor = vbBlue
        PDFPrinter.PDFSetLineStyle = pPDF_SOLID
        PDFPrinter.PDFSetLineWidth = 0.85
        PDFPrinter.PDFSetDrawMode = DRAW_NORMAL
        PDFPrinter.PDFDrawRectangle 15, 150, 400, 50

        PDFPrinter.PDFImage App.Path & "\NeO78.jpg", 15, 220, 150, 100, "http://www.google.fr"
        
        PDFPrinter.PDFSetFont FONT_ARIAL, 12, FONT_BOLD
        PDFPrinter.PDFSetTextColor = vbBlack
        PDFPrinter.PDFSetDrawColor = vbYellow
        PDFPrinter.PDFSetLineColor = vbBlack
        PDFPrinter.PDFSetAlignement = ALIGN_LEFT
        PDFPrinter.PDFSetBorder = BORDER_ALL
        PDFPrinter.PDFSetLineWidth = 1
        PDFPrinter.PDFSetFill = True
        PDFPrinter.PDFCell "Test Alignement  Gauche", 15, 350, 150, 20
        
        PDFPrinter.PDFSetFont FONT_ARIAL, 8, FONT_ITALIC
        PDFPrinter.PDFSetTextColor = vbBlack
        PDFPrinter.PDFTextOut "Page " & PDFPrinter.PDFPageNumber, _
                         PDFPrinter.PDFGetPageWidth / 2 - PDFPrinter.PDFGetStringWidth("Page " & PDFPrinter.PDFPageNumber), _
                         PDFPrinter.PDFGetPageHeight - PDFPrinter.PDFTextHeight
                         
        PDFPrinter.PDFEndPage
                                 
        PDFPrinter.PDFNewPage

        PDFPrinter.PDFSetBookmark "Signet 2", 0, 40
        PDFPrinter.PDFSetBookmark "Sous-Signet 2", 1, 60
        
        PDFPrinter.PDFSetFont FONT_ARIAL, 15, FONT_BOLD
        PDFPrinter.PDFSetTextColor = vbBlack
        PDFPrinter.PDFTextOut "Signet 2", 15, 40

        PDFPrinter.PDFSetFont FONT_ARIAL, 15, FONT_BOLD & FONT_UNDERLINE
        PDFPrinter.PDFSetTextColor = vbRed
        PDFPrinter.PDFTextOut "Sous-Signet 2", 15, 60
        
        PDFPrinter.PDFSetDrawColor = vbCyan
        PDFPrinter.PDFSetLineColor = vbMagenta
        PDFPrinter.PDFSetLineStyle = pPDF_SOLID
        PDFPrinter.PDFSetLineWidth = 0.65
        PDFPrinter.PDFSetDrawMode = DRAW_DRAW
        PDFPrinter.PDFDrawRectangle 15, 80, 400, 50

        PDFPrinter.PDFSetLineColor = vbBlue
        PDFPrinter.PDFSetLineStyle = pPDF_SOLID
        PDFPrinter.PDFSetLineWidth = 0.85
        PDFPrinter.PDFSetDrawMode = DRAW_NORMAL
        PDFPrinter.PDFDrawRectangle 15, 150, 400, 50

        PDFPrinter.PDFImage App.Path & "\NeO78.jpg", 15, 220, 150, 100, "http://www.google.fr"
        
        PDFPrinter.PDFSetFont FONT_ARIAL, 12, FONT_BOLD
        PDFPrinter.PDFSetTextColor = vbBlack
        PDFPrinter.PDFSetDrawColor = vbYellow
        PDFPrinter.PDFSetLineColor = vbBlack
        PDFPrinter.PDFSetAlignement = ALIGN_LEFT
        PDFPrinter.PDFSetBorder = BORDER_ALL
        PDFPrinter.PDFSetLineWidth = 1
        PDFPrinter.PDFSetFill = True
        PDFPrinter.PDFCell "Test Alignement  Gauche", 15, 350, 150, 20
        
        PDFPrinter.PDFSetFont FONT_ARIAL, 8, FONT_ITALIC
        PDFPrinter.PDFSetTextColor = vbBlack
        PDFPrinter.PDFTextOut "Page " & PDFPrinter.PDFPageNumber, _
                         PDFPrinter.PDFGetPageWidth / 2 - PDFPrinter.PDFGetStringWidth("Page " & PDFPrinter.PDFPageNumber), _
                         PDFPrinter.PDFGetPageHeight - PDFPrinter.PDFTextHeight
                             
    PDFPrinter.PDFEndDoc
End Sub
